
#include <avr/pgmspace.h>
#include <stdbool.h>
#include <stdint.h> 
#include "defines.h"
#include <util/delay.h>
#include "i2clcd.h"
#include "i2cmaster.h"
#include "defines.h"


/*
Lese- und Schreibfunktionen, basieren auf
#include "i2cmaster.h"//fleury
#include "twimaster.c"//fleury
vorher einbinden
*/

#ifndef _kk_twi_funktionen_c
	#define _kk_twi_funktionen_c

u8 WDY,MON, YEA,DAY,ds1307gefunden;

#define kkI2Clcd2   1
uint8_t mcp23017_72_A, mcp23017_72_B;

//#####################################################################################
  void kk_ds1307_setTime(int houDCB,int minDCB, int secDCB){
  	secDCB=((secDCB/10)<<4)|(secDCB%10);   //DS1307Write(0x00,temp);
	minDCB=((minDCB/10)<<4)|(minDCB%10);	//DS1307Write(0x01,temp);
	houDCB=((houDCB/10)<<4)|(houDCB%10);	//DS1307Write(0x02,temp);
//	houDCB=houDCB & 0b01000000;	//6.bit fr 24h-Modus;
	//Now write time back to RTC Module
		i2c_start_wait(0xD0);     				// set device address and write mode
        i2c_write(0x00);                        // write start address = 0
        i2c_write(secDCB);                      // write data to address 0
        i2c_write(minDCB);                      //    "    "   "    "    1
        i2c_write(houDCB);                      //    "    "   "    "    2
  //      i2c_write(0x00);                      	//   am/pm
        i2c_stop();                             // set stop conditon = release bus
  }
//#####################################################################################

void  kk_ds1307_getAll_to_global_struct_zt(){
int z[8];   
   i2c_start_wait(0xD0);      // set device address and write mode
        i2c_write(0x00);                           // write address = 0
        i2c_rep_start(0xD0+I2C_READ);        // set device address and read mode
        z[0] = i2c_readAck();                        // read one byte form address 0
        z[1] = i2c_readAck();                        // read one byte form address 0
        z[2] = i2c_readAck();                        //  "    "    "    "     "    1
        z[3] = i2c_readAck();                        //  "    "    "    "     "    3
        z[4] = i2c_readAck();                        // read one byte form address 0
        z[5] = i2c_readAck();                        //  "    "    "    "     "    1
        z[6] = i2c_readNak();                        //  "    "    "    "     "    3
 
/*		for(i=0;i<8;i++) {z[i] = i2c_readAck();}                       // read one byte form address 0
*/		
        i2c_stop();                                // set stop condition = release bus
		sec=(((z[0] & 0b11110000)>>4)*10)+(z[0] & 0b00001111);
		min=(((z[1] & 0b11110000)>>4)*10)+(z[1] & 0b00001111);
		hou=(((z[2] & 0b11110000)>>4)*10)+(z[2] & 0b00001111);
		WDY=(((z[3] & 0b11110000)>>4)*10)+(z[3] & 0b00001111);
		DAY=(((z[4] & 0b11110000)>>4)*10)+(z[4] & 0b00001111);
		MON=(((z[5] & 0b11110000)>>4)*10)+(z[5] & 0b00001111);
		YEA=(((z[6] & 0b11110000)>>4)*10)+(z[6] & 0b00001111);

/*		zt.se=(((z[0] & 0b11110000)>>4)*10)+(z[0] & 0b00001111);
		zt.mi=(((z[1] & 0b11110000)>>4)*10)+(z[1] & 0b00001111);
		zt.ho=(((z[2] & 0b11110000)>>4)*10)+(z[2] & 0b00001111);
		zt.wd=(((z[3] & 0b11110000)>>4)*10)+(z[3] & 0b00001111);
		zt.da=(((z[4] & 0b11110000)>>4)*10)+(z[4] & 0b00001111);
		zt.mo=(((z[5] & 0b11110000)>>4)*10)+(z[5] & 0b00001111);
		zt.ye=(((z[6] & 0b11110000)>>4)*10)+(z[6] & 0b00001111);
*/
}
//#####################################################################################

void  kk_ds1307_synchronize_min_hou(){
int z[3];
uint8_t ret;   
   ret=i2c_start_wait(0xD0);      // set device address and write mode
   if(ret)return 1;
        i2c_write(0x00);                           // write address = 0
        i2c_rep_start(0xD0+I2C_READ);        // set device address and read mode
        z[0] = i2c_readAck();                        // read one byte form address 0
        z[1] = i2c_readAck();                        // read one byte form address 0
        z[2] = i2c_readNak();                        //  "    "    "    "     "    3
 
/*		for(i=0;i<8;i++) {z[i] = i2c_readAck();}                       // read one byte form address 0
*/		
        i2c_stop();                                // set stop condition = release bus
		min=(((z[1] & 0b11110000)>>4)*10)+(z[1] & 0b00001111);
		hou=(((z[2] & 0b11110000)>>4)*10)+(z[2] & 0b00001111);
}
//#####################################################################################

//#####################################################################################
  void kk_ds1307_setDate(int dayDCB,int monDCB, int yeaDCB){
  	dayDCB=((dayDCB/10)<<4)|(dayDCB%10);   //DS1307Write(0x00,temp);
	monDCB=((monDCB/10)<<4)|(monDCB%10);	//DS1307Write(0x01,temp);
	yeaDCB=((yeaDCB/10)<<4)|(yeaDCB%10);	//DS1307Write(0x02,temp);
//	houDCB=houDCB & 0b01000000;	//6.bit fr 24h-Modus;
	//Now write time back to RTC Module
		i2c_start_wait(0xD0);     				// set device address and write mode
        i2c_write(0x04);                        // write start address = 0
        i2c_write(dayDCB);                      // write data to address 0
        i2c_write(monDCB);                      //    "    "   "    "    1
        i2c_write(yeaDCB);                      //    "    "   "    "    2
  //      i2c_write(0x00);                      	//   am/pm
        i2c_stop();                             // set stop conditon = release bus
  }
//#####################################################################################
//#####################################################################################
  void kk_ds1307_setAll(){
 int z[8],i;   
 	z[0]=((sec/10)<<4)|(sec%10);   //DS1307Write(0x00,temp);
	z[1]=((min/10)<<4)|(min%10);	//DS1307Write(0x01,temp);
	z[2]=((hou/10)<<4)|(hou%10);	//DS1307Write(0x02,temp);
	z[3]=((WDY/10)<<4)|(WDY%10);	//DS1307Write(0x02,temp);
    z[4]=((DAY/10)<<4)|(DAY%10);   //DS1307Write(0x00,temp);
	z[5]=((MON/10)<<4)|(MON%10);	//DS1307Write(0x01,temp);
	z[6]=((YEA/10)<<4)|(YEA%10);	//DS1307Write(0x02,temp);
/* 	z[0]=((zt.se/10)<<4)|(zt.se%10);   //DS1307Write(0x00,temp);
	z[1]=((zt.mi/10)<<4)|(zt.mi%10);	//DS1307Write(0x01,temp);
	z[2]=((zt.ho/10)<<4)|(zt.ho%10);	//DS1307Write(0x02,temp);
	z[3]=((zt.wd/10)<<4)|(zt.wd%10);	//DS1307Write(0x02,temp);
    z[4]=((zt.da/10)<<4)|(zt.da%10);   //DS1307Write(0x00,temp);
	z[5]=((zt.mo/10)<<4)|(zt.mo%10);	//DS1307Write(0x01,temp);
	z[6]=((zt.ye/10)<<4)|(zt.ye%10);	//DS1307Write(0x02,temp);*/
//	houDCB=houDCB & 0b01000000;	//6.bit fr 24h-Modus;
	//Now write time back to RTC Module
i2c_start_wait(0xD0);     				// set device address and write mode
i2c_write(0x00);                        // write start address = 0
  for(i=0;i<8;i++) {
          i2c_write(z[i]);                      // write data to address 0
	}
 i2c_stop();                             // set stop conditon = release bus
  }
//#####################################################################################

void i2c_scanner( void ){
uint8_t i,abfr;
i2c_init();
	for(i=0;i<254;i+=2){
		abfr=i2c_start(i);
			if(abfr){
			//not found
			}else{
			//found
			
			}
	}

}




#endif
